;;; ----------------------------------------------------------
;;; Bibliothque de FONCTIONS standards
;;;

;;; -------------------------------------------------
;;; DEBUT () dmarrage d'une fonction C: !!!
;;;

(defun	DEBUT()

	(setvar		"CMDECHO"	0)	;;; masque l'affichage des commandes
	(setvar		"OSNAPCOORD"	1)	;;; priorit aux coordonnes et NON les accrochages
	(command	"_blipmode"	0)	;;; dsactive les marques 
  	(graphscr)				;;; bascule sur cran GRAPHIQUE

(princ)

);defun

;;; -------------------------------------------------
;;; SAUVER les paramtres utilisateur
;;;

(defun	SAVE_PARAM()

    	(setq	OLD_PLINEWID	(getvar "PLINEWID")	;;; Epaisseur des polylignes
		OLD_OSMODE	(getvar "OSMODE")	;;; liste des ACCROCHAGES
		OLD_ATTDIA	(getvar "ATTDIA")	;;; dsactive case de dialogue des attributs
	);setq

(princ)

);defun

;;; -------------------------------------------------
;;; RESTAORER les paramtres utilisateur
;;;

(defun	USER_PARAM()

 	(setvar "PLINEWID"	OLD_PLINEWID)		;;; Epaisseur des polylignes
 	(setvar "OSMODE"	OLD_OSMODE)		;;; liste des ACCROCHAGES
 	(setvar "ATTDIA"	OLD_ATTDIA)		;;; restitue valeur case de dialogue des attributs

(princ)

);defun

;;: ----------------------------------------------
;;; gestion des erreurs
;;;

(defun	*error*(ERR)
  
  	(princ ERR)

  	(if	OLD_PLINEWID

	  	(user_param)
	);if
  
);defun


;;: ----------------------------------------------
;;; Slectionner une srie d'objets
;;; en indiquant 1er - Dernier Objet
;;;

(defun SSPART(entdepart entarrivee) ;;;;;;;;  / ent entx ss)

	(setq SSENT (ssadd))

	(setq entdep entdepart)
	  
	(if (= entdepart nil)
		(setq entdepart (entnext))
	)
	  
	(setq ent entdepart)
	  
	(while (and (not (equal nil (setq entx (entnext ent))))
		
        	(not (equal entx entarrivee)))
      
        	(ssadd entx SSENT)
      
        	(setq ent entx)
    )
  
    (if (equal nil entx) (*error* "Mauvais arguments pour sspart")
      
                         (ssadd entx SSENT))

  	(if (= entdep nil) (ssadd entdepart SSENT))
  
    (eval SSENT)
)

;;; -----------------------------------------------------------------------------
;;; slectionner plusieurs objets entre 1 objet de DEBUT et un Objet de FIN
;;;
;;; le jeu de slection   SELECTENT   est cr...
(defun SSENT (ENTDEPART ENTFIN)
	  
	(setq	SELECTENT	(ssadd)				;;; cration d'un jeu de slection VIDE
	 	ENT		ENTDEPART			;;; mmorise l'objet de dpart
	);setq
	  
	(while ENT
         	(ssadd ENT SELECTENT)				;;; ajoute ENT dans le jeu de slection SELECTENT
        	(setq ENT	(entnext	ENT)	)	;;; passe  l'entit suivante

		(if	(equal	ENT	ENTFIN)			;;; TEST si objet = Objet de FIN
		   	(progn
				(ssadd	ENT	SELECTENT )	;;; ajoute l'entit FIN au jeu de slection SELECTENT
				(setq	ENT	nil	  )	;;; remet ENT  nil
			);progn
		);if
	);while
(princ)
);defun


;;; ----------------------------------------------------------------------------
;;; SCU dessus = SCG

(defun	SCU_HAUT()
  	(command	"_ucs"	"_W")
(princ)
);defun

;;; ----------------------------------------------------------------------------
;;; SCU FACE (X = 90 du SCG)

(defun	SCU_FACE()
  	(command	"_ucs"	"_W")
  	(command	"_ucs"	"X"	"90.0")
(princ)
);defun

;;; ----------------------------------------------------------------------------
;;; SCU DROITE (X = 90 du SCG + Y = 90 du SCG)

(defun	SCU_DROITE()
  	(command	"_ucs"	"_W")
  	(command	"_ucs"	"X"	"90.0")
  	(command	"_ucs"	"Y"	"90.0")
(princ)
);defun

;;; ------------------------------ fin programme RECTANGLE.LSP -------------------------

(prompt	"\n(DEBUT)         = fonction  placer au dbut d'une fonction C:...")
(prompt	"\n(SAVE_PARAM)    = fonction pour sauvegarder les variables de l'utilisateur...")
(prompt	"\n(USER_PARAM)    = fonction pour restituer les variables de l'utilisateur...")
(prompt	"\n(SSENT DEB FIN) = fonction pour slectionner des objets entre objet dbut et objet FIN...")
(prompt	"\n(SCU_HAUT)      = bascule sur le SCU HAUT = Gnral !...")
(prompt	"\n(SCU_FACE)      = bascule sur le SCU FACE...")
(prompt	"\n(SCU_DROITE)    = bascule sur le SCU DROITE...")
 
(princ)
