;;;	Agena CAO Alsace-Lorraine
;;;
;;;	Programme de conversion d'chelle pour les
;;;	TEXTES, les ATTRIBUTS
;;;	Application d'un coef. d'chelle
;;;
;;;	par Christian REB le 05/08/1993
;;;

(defun c:chg() (command "edix" "coef.lsp") (load"coef") )

;;; ////////////////////////////////////////////////
;;; Initialise les paramtres au chargement
;;; ////////////////////////////////////////////////
;;;
 
(setq	coef_ech 1 )
 ;(setvar "cmdecho" 1)

;;; ////////////////////////////////////////////////
;;; Fonction principale()
;;; ////////////////////////////////////////////////
;;;

(defun c:coef ( / nb_t nb_a filtre_t filtre_a )

(command "annuler" "m")

	(setq	nombloc	   "echelle_globale_dessin"
		filtre_t   (list (cons 0 "text"  ) )
		filtre_a   (list (cons 0 "insert") )
		nb_t 0
		nb_b 0
	);setq

	(initget "T t B b D d")
	(setq rep (getkword "\n\nCoefficient d'chelle : Textes, Blocs, les Deux : "
		  );getkword
	);setq

	(cond
		( (= rep nil) (princ) )
		( (= (strcase rep) "T" )  (modif_t   filtre_t          ) )
		( (= (strcase rep) "B" )  (modif_b   filtre_a          ) )
		( (= (strcase rep) "D" )  (modif_tb  filtre_t filtre_a ) )
	);cond

(princ)
);defun

;;; ////////////////////////////////////////////////
;;; Sous/Fonction des TEXTES
;;; ////////////////////////////////////////////////
;;;

(defun modif_t ( filtre_obj )

	(modif_coef)
	(sauve_param)
	(modif_texte filtre_obj)
	(old_param)

);defun

;;; ////////////////////////////////////////////////
;;; Sous/Fonction des BLOCS
;;; ////////////////////////////////////////////////
;;;

(defun modif_b ( filtre_obj )

	(modif_coef)
	(sauve_param)
	(modif_bloc filtre_obj)
	(old_param)

);defun

;;; ////////////////////////////////////////////////
;;; Sous/Fonction des TEXTES et BLOCS
;;; ////////////////////////////////////////////////
;;;

(defun modif_tb ( filtre_objt filtre_obja)

	(modif_coef)
	(sauve_param)
	(modif_texte   filtre_objt   ) 
	(modif_bloc    filtre_obja   )
	(old_param)

);defun

;;; ////////////////////////////////////////////////
;;; Modification du coef. d'echelle du dessin
;;; ////////////////////////////////////////////////
;;;

(defun modif_coef( / var )

	(prompt "\n\nCoefficient  appliquer aux objets : <")(princ coef_ech)(prompt "> : ") 
	(setq var (getdist "") )
	
	(if (/= var nil)
		(setq coef_ech var)
	);if

	(while (<= coef_ech 0)
		(prompt "\n\nCoefficient  appliquer aux objets : <")(princ coef_ech)(prompt "> : ") 
		(setq coef_ech (getdist "") )
	);while
		
);defun modif_coef

;;; ////////////////////////////////////////////////
;;; Calcul de la hauteur du texte
;;; ////////////////////////////////////////////////
;;;

(defun calcul_haut ( haut )

	(setq new_haut (* haut coef_ech) )

);defun
		
;;; ////////////////////////////////////////////////
;;; Modification Hauteur des TEXTES par le Coef.
;;; ////////////////////////////////////////////////
;;;

(defun modif_texte ( filtre_obj  / old_haut elt_ent)

	(if (/= coef_ech 1)
	(progn

	(select_obj filtre_obj)

	(if (= ent nil)
		(progn
			(prompt"\n\n*** AUCUN texte dans le dessin ???... \n")
			(write-char 7)
		);progn
	);if
	(setq elt_ent (ssname ent 0) )

	(while (/= elt_ent nil)
		(setq	old_haut (cdr (assoc 40 (entget elt_ent) ) )
		);setq
		(calcul_haut old_haut)			; calcul nouvelle hauteur = NEW_HAUT
		(substlist (entget elt_ent) 40 new_haut)  
		(setq	ent (ssdel elt_ent ent)
			elt_ent	(ssname ent 0)
			nb_t (+ 1 nb_t)
		);setq
	);while

	(prompt "\n\tTextes changs ---> ") (princ nb_t) 
	);progn si coef_ech /= 1

	(prompt "\nCoefficient = 1... aucun changement pour les TEXTES")

	);if

(princ)
);defun modif_texte

;;; ////////////////////////////////////////////////
;;; Modification Hauteur des BLOCS par le Coef.
;;; ////////////////////////////////////////////////
;;;

(defun modif_bloc ( filtre_obj )

	(if (/= coef_ech 1)
	(progn

	(select_obj filtre_obj)

	(if (= ent nil)
		(progn
			(prompt"\n\n*** AUCUN bloc dans le dessin ???... \n")
			(write-char 7)
		);progn
	);if
	(setq elt_ent (ssname ent 0) )

	(while (/= elt_ent nil)

		(setq	pt_bl (cdr (assoc 10 (entget elt_ent) ) )
		);setq
		(command "echelle" elt_ent "" pt_bl coef_ech)
		(setq	ent (ssdel elt_ent ent)
			elt_ent	(ssname ent 0)
			nb_b (+ 1 nb_b)
		);setq
	);while

	(prompt "\n\tBlocs changs ---> ") (princ nb_b) 
	);progn si coef_ech /= 1

	(prompt "\nCoefficient = 1... aucun changement pour les BLOCS")

	);if

(princ)
);defun modif_texte

;;; ////////////////////////////////////////////////
;;; Modification des listes d'entits
;;; ////////////////////////////////////////////////
;;;
;;;		nom_list	= liste  traiter
;;;		code		= code entit  changer
;;;		new_val		= Nouvelle Hauteur de texte
;;;		new_list	= Nouvelle LISTE 
;;;

(defun substlist ( nom_list code new_val )

	(setq	new_list (subst (cons 40 new_val) (assoc code nom_list) nom_list )
	);setq
	(entmod new_list)

);defun

;;; ////////////////////////////////////////////////
;;; Selection des objets du dessin
;;; ////////////////////////////////////////////////
;;;

(defun select_obj( filtre_obj )

	;(setq	ent	(ssget "x" filtre_obj )
	;);setq
	(setq	ent	(ssget "f" (getvar "extmin") (getvar "extmax") filtre_obj )
	);setq

);defun select_obj

;;; ////////////////////////////////////////////////
;;; Sauvegarde des paramtres utilisateurs
;;; ////////////////////////////////////////////////
;;;

(defun sauve_param()

	;;; sauve les pamtres utilisateur

	(setq	old_cmdecho	(getvar "cmdecho")
		old_high	(getvar "highlight")
	);setq


	;;; initialise les pamtres programme

	(setvar "cmdecho"	0 )
	(setvar "highlight"	0 )

);defun sauve_param

;;; ////////////////////////////////////////////////
;;; Restitution des paramtres sauvegards
;;; ////////////////////////////////////////////////
;;;

(defun old_param()

	(setvar "cmdecho"	old_cmdecho	)
	(setvar "highlight"	old_high	)

);defun sauve_param


;;; ********** fin programme **************************

(prompt "\n\tTaper  COEF  pour affecter les TEXTES et BLOCSS d'un coef.")
(prompt "\n\n*** ATTENTION ***")
(prompt "\n\tSeul les objets affichs seront modifis.")
(prompt "\n\tLes objets sur un plan LOCK perturbent les modifications.")

(princ)
