;; INS3D -Gilles Chanteau- (gile) 11/04/07
;; Insre un bloc dans le plan spcifi par 3 points
;; INS3D pour choisir le bloc dans la boite de dialogue
;; -INS3D pour entrer le nom  la ligne de commande.

(defun c:ins3d (/ nam)
  (and
    (setq nam (getBlock nil))
    (ins3d nam)
  )
  (princ)
)

(defun c:-ins3d	(/ nam)
  (and
    (setq nam (getstring T "\Entrez le nom du bloc  insrer: "))
    (or	(tblsearch "BLOCK" nam)
	(findfile nam)
	(findfile (setq nam (strcat nam ".dwg")))
    )
    (ins3d nam)
  )
  (princ)
)

(defun ins3d (nam / AcDoc Space opt xsc ysc zsc xpt ypt blk nor)
  (setq	AcDoc (vla-get-ActiveDocument (vlax-get-acad-object))
	Space (if (= 1 (getvar "CVPORT"))
		(vla-get-PaperSpace AcDoc)
		(vla-get-ModelSpace AcDoc)
	      )
  )
  (if (not
	(setq opt
	       (getpoint
		 "\nSpcifiez le point d'insertion ou < Echelle >: "
	       )
	)
      )
    (progn
      (if
	(not (setq
	       xsc (getreal
		     "\nEntrez le facteur d'chelle en  X < 1 >: "
		   )
	     )
	)
	 (setq xsc 1.0)
      )
      (if (not (setq
		 ysc
		  (getreal
		    "\nEntrez le facteur d'chelle en Y < utiliser le facteur d'chelle en X >: "
		  )
	       )
	  )
	(setq ysc xsc)
      )
      (if (not (setq
		 zsc
		  (getreal
		    "\nEntrez le facteur d'chelle en Z < utiliser le facteur d'chelle en X >: "
		  )
	       )
	  )
	(setq zsc xsc)
      )
      (initget 1)
      (setq opt (getpoint "\nSpcifiez le point d'insertion: "))
    )
    (setq xsc 1
	  ysc 1
	  zsc 1
    )
  )
  (setq	xpt opt
	ypt opt
  )
  (while (equal xpt opt 1e-9)
    (setq xpt
	   (getpoint
	     opt
	     "\nSpcifiez un point dans la zone positive de l'axe X du bloc:"
	   )
    )
  )
  (while (or (equal ypt opt 1e-9) (equal ypt xpt 1e-9))
    (setq ypt
	   (getpoint
	     opt
	     "\nSpcifiez un point dans la zone des Y positifs: "
	   )
    )
  )
  (foreach p '(opt xpt ypt)
    (set p (trans (eval p) 1 0))
  )
  (if (setq blk
	     (vla-InsertBlock
	       Space
	       (vlax-3d-Point '(0 0 0))
	       nam
	       xsc
	       ysc
	       zsc
	       0.0
	     )
      )
    (progn
      (vla-TransformBy
	blk
	(vlax-tmatrix
	  (append
	    (mapcar
	      '(lambda (v o)
		 (append v (list o))
	       )
	      (mxm
		(trp
		  (reverse
		    (list
		      (setq nor (norm_3pts opt xpt ypt))
		      (norm_3pts '(0 0 0) nor (mapcar '- xpt opt))
		      (vec1 opt xpt)
		    )
		  )
		)
		(mapcar
		  '(lambda (v) (trans v (trans '(0 0 1) 1 0 T) 0 T))
		  '((1 0 0) (0 1 0) (0 0 1))
		)
	      )
	      opt
	    )
	    (list '(0 0 0 1))
	  )
	)
      )
      (setvar "INSNAME" (vl-filename-base nam))
    )
  )
)

;;; Getblock (gile) 03/11/07
;;; Retourne le nom du bloc entr ou choisi par l'utilisateur 
;;; dans une liste droulante de la boite de dialogue ou depuis la boite
;;; de dialogue standard d'AutoCAD
;;; Argument : le titre (string) ou nil (dfaut : "Choisir un bloc")

(defun getblock	(titre / bloc n lst tmp file what_next dcl_id nom)
  (while (setq bloc (tblnext "BLOCK" (not bloc)))
    (setq lst (cons (cdr (assoc 2 bloc)) lst)
    )
  )
  (setq	lst  (acad_strlsort
	       (vl-remove-if
		 (function (lambda (n) (= (substr n 1 1) "*")))
		 lst
	       )
	     )
	tmp  (vl-filename-mktemp "Tmp.dcl")
	file (open tmp "w")
  )
  (write-line
    (strcat
      "getblock:dialog{label="
      (cond (titre (vl-prin1-to-string titre))
	    ("\"Choisir un bloc\"")
      )
      ";initial_focus=\"bl\";:boxed_column{
      :row{:text{label=\"Slectionner\";alignment=left;}
      :button{label=\">>\";key=\"sel\";alignment=right;fixed_width=true;}}
      spacer;
      :column{:button{label=\"Parcourir...\";key=\"wbl\";alignment=right;fixed_width=true;}}
      :column{:text{label=\"Nom :\";alignment=left;}}
      :edit_box{key=\"tp\";edit_width=25;}
      :popup_list{key=\"bl\";edit_width=25;}spacer;}
      spacer;
      ok_cancel;}"
    )
    file
  )
  (close file)
  (setq dcl_id (load_dialog tmp))
  (setq what_next 2)
  (while (>= what_next 2)
    (if	(not (new_dialog "getblock" dcl_id))
      (exit)
    )
    (start_list "bl")
    (mapcar 'add_list lst)
    (end_list)
    (if	(setq n	(vl-position
		  (strcase (getvar "INSNAME"))
		  (mapcar 'strcase lst)
		)
	)
      (setq nom (nth n lst))
      (setq nom	(car lst)
	    n	0
      )
    )
    (set_tile "bl" (itoa n))
    (action_tile "sel" "(done_dialog 5)")
    (action_tile "bl" "(setq nom (nth (atoi $value) lst))")
    (action_tile "wbl" "(done_dialog 3)")
    (action_tile "tp" "(setq nom $value) (done_dialog 4)")
    (action_tile
      "accept"
      "(setq nom (nth (atoi (get_tile \"bl\")) lst)) (done_dialog 1)"
    )
    (setq what_next (start_dialog))
    (cond
      ((= what_next 3)
       (if (setq nom (getfiled "Slectionner un fichier" "" "dwg" 0))
	 (setq what_next 1)
	 (setq what_next 2)
       )
      )
      ((= what_next 4)
       (cond
	 ((not (read nom))
	  (setq what_next 2)
	 )
	 ((tblsearch "BLOCK" nom)
	  (setq what_next 1)
	 )
	 ((findfile (setq nom (strcat nom ".dwg")))
	  (setq what_next 1)
	 )
	 (T
	  (alert (strcat "Le fichier \"" nom "\" est introuvable."))
	  (setq	nom nil
		what_next 2
	  )
	 )
       )
      )
      ((= what_next 5)
       (if (and	(setq ent (car (entsel)))
		(= "INSERT" (cdr (assoc 0 (entget ent))))
	   )
	 (setq nom	 (cdr (assoc 2 (entget ent)))
	       what_next 1
	 )
	 (setq what_next 2)
       )
      )
      ((= what_next 0)
       (setq nom nil)
      )
    )
  )
  (unload_dialog dcl_id)
  (vl-file-delete tmp)
  nom
)

;;; VEC1 (gile)
;;; Retourne le vecteur norm (1 unit) de sens p1 p2

(defun vec1 (p1 p2 / d)
  (if (not (zerop (setq d (distance p1 p2))))
    (mapcar (function (lambda (x1 x2) (/ (- x2 x1) d))) p1 p2)
  )
)

;; VUNIT
;; Retourne le vecteur unitaire d'un vecteur
;;
;; Argument : un vecteur

(defun vunit (v)
  ((lambda (l)
     (if (/= 0 l)
       (mapcar (function (lambda (x) (/ x l))) v)
     )
   )
    (distance '(0 0 0) v)
  )
)

;;; VXV (gile)
;;; Retourne le produit scalaire (rel) de deux vecteurs
(defun vxv (v1 v2)
  (apply '+ (mapcar '* v1 v2))
)

;; V^V
;; Retourne le produit vectoriel (vecteur) de deux vecteurs
;;
;; Arguments : deux vecteurs

(defun v^v (v1 v2)
  (list	(- (* (cadr v1) (caddr v2)) (* (caddr v1) (cadr v2)))
	(- (* (caddr v1) (car v2)) (* (car v1) (caddr v2)))
	(- (* (car v1) (cadr v2)) (* (cadr v1) (car v2)))
  )
)

;; NORM_3PTS
;; Retourne le vecteur normal du plan dfini par 3 points
;;
;; Arguments : trois points

(defun norm_3pts (p0 p1 p2)
  (vunit (v^v (mapcar '- p1 p0) (mapcar '- p2 p0)))
)

;; transpose une matrice Doug Wilson
(defun trp (m)
  (apply 'mapcar (cons 'list m))
)

;; Apply a transformation matrix to a vector by Vladimir Nesterovsky
(defun mxv (m v)
  (mapcar (function (lambda (r) (vxv r v))) m)
)

;; Multiply two matrices by Vladimir Nesterovsky
(defun mxm (m q)
  (mapcar (function (lambda (r) (mxv (trp q) r))) m)
)