;; MSFREEZE R1.7 (gile) 29/08/2008
;; Pour geler des calques spcifis uniquement dans l'onglet objet
;; Merci  Patrick_35 pour vlr-miscellaneous-reactor
;;;
;;; NOTA :  charger automatiquement au dmarrage.
;;;
;;; Modifications
;;; 23/08/08 : ajout de la possibilit de slectionner des calques  l'cran
;;; 27/08/08 : choix du niveau d'imbrication des blocs pour les slections  l'cran
;;; 29/08/08 : bug a avec les calques slectionns  l'cran puis dgels dans la BD

  (vl-load-com)

(defun c:msfreeze (/ lst tmp th fr)

  (or *acdoc*
      (setq *acdoc* (vla-get-activeDocument (vlax-get-acad-object)))
  )
  (or *layers* (setq *layers* (vla-get-layers *acdoc*)))

  (if (= (getvar "TILEMODE") 1)
    (progn
      (foreach l (vlax-ldata-get "MSpaceFreeze" "frozen")
	(and (getItem *layers* l)
	     (= (vla-get-Freeze (vla-item *layers* l)) :vlax-true)
	     (setq tmp (cons l tmp))
	)
      )
      (or *MSpaceFreeze*
	  (setq	*MSpaceFreeze*
		 (vlr-miscellaneous-reactor
		   nil
		   '((:vlr-layoutSwitched . msfreezerea))
		 )
	  )
      )
      (vlax-for	l *layers*
	((lambda (name)
	   (if (/= name (getvar "clayer"))
	     (if (= (vla-get-Freeze l) :vlax-true)
	       (setq th (cons name th))
	       (setq fr (cons name fr))
	     )
	   )
	 )
	  (vla-get-Name l)
	)
      )
      (setq th (mapcar
		 (function
		   (lambda (x)
		     (if (member x tmp)
		       (strcat x " *")
		       x
		     )
		   )
		 )
		 th
	       )
      )
      (setq lst (MSFreezeBox (vl-sort fr '<) (vl-sort th '<)))
      (foreach l (mapcar
		   (function
		     (lambda (x) (vl-string-right-trim " *" x))
		   )
		   (cadr lst)
		 )
	(vla-put-Freeze (vla-item *layers* l) :vlax-false)
	(setq tmp (vl-remove l tmp))
      )
      (foreach l (car lst)
	(vla-put-Freeze (vla-item *layers* l) :vlax-true)
	(setq tmp (cons l tmp))
      )
      (vlax-ldata-put "MSpaceFreeze" "frozen" tmp)
      (or tmp
	  (progn
	    (vlr-remove *MSpaceFreeze*)
	    (setq *MSpaceFreeze* nil)
	  )
      )
      (vla-regen *acdoc* acAllViewports)
    )
    (alert
      "Vous devez tre dans l'onglet objet pour lancer MSFREEZE."
    )
  )
  (princ)
)


;;=========================================================;;

(defun MsFreezeRea (rea lay / false true th)
  (setq th (vlax-ldata-get "MSpaceFreeze" "frozen"))
  (vlax-for l *layers*
    (if	(= (vla-get-Freeze l) :vlax-false)
      (setq false (cons (vla-get-Name l) false))
      (setq true (cons (vla-get-Name l) true))
    )
  )
  (cond
    ((= (car lay) "Model")
     (foreach l (common true th)
       (vlax-ldata-put
	     "MSpaceFreeze"
	     "frozen"
	     (vl-remove l th)
	   )
       )
     (foreach l	th
       (if (= (getvar "CLAYER") l)
	 (vlax-ldata-put
	   "MSpaceFreeze"
	   "frozen"
	   (vl-remove l th)
	 )
	 (vla-put-Freeze (vla-item *layers* l) :vlax-true)
       )
     )
     (setq *FromPaperSpace* nil)
    )
    (T
     (if (not *FromPaperSpace*)
       (progn
	 (foreach l (common th false)
	   (vlax-ldata-put
	     "MSpaceFreeze"
	     "frozen"
	     (vl-remove l th)
	   )
	 )
	 (foreach l th
	   (vla-put-Freeze (vla-item *layers* l) :vlax-false)
	 )
       )
     )
     (setq *FromPaperSpace* T)
    )
  )
  (vla-regen *acdoc* acAllViewports)
)

;;=========================================================;;

;;; GetItem (gile)
;;; Retourne le vla-object de l'item s'il est prsent dans la collection
;;;
;;; Arguments
;;; col : la collection (vla-object)
;;; name : le nom de l'objet (string) ou son indice (entier)
;;;
;;; Retour : le vla-object ou nil

(defun GetItem (col name / obj)
  (vl-catch-all-apply
    '(lambda () (setq obj (vla-item col name)))
  )
  obj
)

;;=========================================================;;

;;; COMMON (gile)
;;; Retourne la liste des lments communs  lst1 et lst2
;;; (COMMON '(1 2 3 4) '( 2 3 4 5)) -> (2 3 4)
(defun common (l1 l2)
  (if l1
    (if	(member (car l1) l2)
      (cons (car l1) (common (cdr l1) l2))
      (common (cdr l1) l2)
    )
  )
)

;;=========================================================;;

;; str2lst
;; Transforme un chaine avec sparateur en liste de chaines
;;
;; Arguments
;; str : la chaine  transformer en liste
;; sep : le sparateur
;;
;; Exemples
;; (str2lst "a b c" " ") -> ("a" "b" "c")
;; (str2lst "1,2,3" ",") -> ("1" "2" "3")
;; (mapcar 'read (str2lst "1,2,3" ",")) -> (1 2 3)

(defun str2lst (str sep / pos)
  (if (setq pos (vl-string-search sep str))
    (cons (substr str 1 pos)
	  (str2lst (substr str (+ (strlen sep) pos 1)) sep)
    )
    (list str)
  )
)

;;=========================================================;;

;; lst2str
;; Concatne une liste et un sparateur en une chaine
;;
;; Arguments
;; lst : la liste  transformer en chaine
;; sep : le sparateur
;;
;; Exemples
;; (lst2str '(1 2 3) ",") -> "1,2,3"
;; (lst2str '("a" "b" "c") " ") -> "a b c"

(defun lst2str (lst sep)
  (if (cadr lst)
    (strcat (vl-princ-to-string (car lst))
	    sep
	    (lst2str (cdr lst) sep)
    )
    (vl-princ-to-string (car lst))
  )
)

;;=========================================================;;

;; MSFreezebox (gile)
;; Boite de dialogue

(defun MSFreezebox (fr	  th	/     len   tmp	  file	dcl_id
		    freeze	thaw  ret   ss	  lay	lst   frv
		    thv	  pos kw u-lst
		   )
  (defun lst2val (sub lst)
    (lst2str
      (mapcar (function (lambda (x) (itoa (vl-position x lst))))
	      sub
      )
      " "
    )
  )
  (defun val2lst (val lst)
    (mapcar
      (function (lambda (x) (nth (atoi x) lst))) (str2lst val " ")
    )
  )
  (setq	len  (max (length fr) (length th))
	wid  (+ 8 (apply 'max (mapcar 'strlen (append fr th))))
	tmp  (vl-filename-mktemp "tmp.dcl")
	file (open tmp "w")
  )
  (write-line
    (strcat
      "MSFreezbox:dialog{label=\"Geler dans l'espace objet\";"
      ":text{label=\"Calque courant : "
      (getvar "clayer")
      "\";}spacer;:row{"
    )
    file
  )
    (write-line
      (strcat
	":column{width="
	(itoa wid)
	";:list_box{label=\"Geler\";key=\"freeze\";
	multiple_select=true;width=40;height="
	(cond
	  ((< 50 len) "50")
	  ((< 10 len) (itoa (1+ len)))
	  (T "10")
	)
	";}:button{key=\"sel\";label=\"Slection >>\";fixed_width=true;}}"
      )
      file
    )
    (write-line
      (strcat
	":column{width="
	(itoa wid)
	";:list_box{label=\"Dgeler\";key=\"thaw\";
        multiple_select=true;width=40;height="
	(cond
	  ((< 50 len) "50")
	  ((< 10 len) (itoa (1+ len)))
	  (T "10")
	)
	";}:text{label=\"* gel en espace objet\"; alignment=left;}}"
      )
      file
    )
  (write-line "}spacer;ok_cancel;}" file)
  (close file)
  (setq	dcl_id	  (load_dialog tmp)
	what_next 2
  )
  (while (< 1 what_next)
    (if	(not (new_dialog "MSFreezbox" dcl_id))
      (exit)
    )
    (and fr
	 (start_list "freeze")
	 (mapcar 'add_list fr)
	 (end_list)
    )
    (and th
	 (start_list "thaw")
	 (mapcar 'add_list th)
	 (end_list)
    )
    (and frv (set_tile "freeze" (lst2val frv fr)))
    (and thv (set_tile "thaw" (lst2val thv th)))
    (action_tile "freeze" "(setq frv (val2lst $value fr))")
    (action_tile
      "thaw"
      "(setq thv (val2lst $value th))
      (foreach n
      (common (mapcar (function (lambda (x)
      (vl-string-right-trim \" *\" x))) thv) freeze)
      (setq freeze (vl-remove n freeze)))")
    (action_tile "sel" "(done_dialog 3)")
    (action_tile
      "accept"
      "(or (not (setq ret (get_tile \"freeze\")))
      (= ret \"\")
      (foreach n (str2lst ret \" \")
      (setq freeze (cons (nth (atoi n) fr) freeze))))
      (or (not (setq ret (get_tile \"thaw\")))
      (= ret \"\")
      (foreach n (str2lst ret \" \")
      (setq thaw (cons (nth (atoi n) th) thaw))))
      (done_dialog 1)"
    )
    (setq what_next (start_dialog))
    (if	(= 3 what_next)
      (progn
	(or *MsFreezeNestingLevel*
	    (setq *MsFreezeNestingLevel* "Bloc")
	)
	(princ
	  (strcat "\nParamtre courant : Niveau d'imbrication de bloc = "
		  *MsFreezeNestingLevel*
	  )
	)
	(while (or (initget "Imbrication annUler")
		   (setq ent
			  (nentsel
			    "\nSlectionnez un objet du calque  geler ou [Imbrication/annUler]: "
			  )
		   )
	       )
	  (cond
	    ((= ent "Imbrication")
	     (initget "Entit Bloc Aucun")
	     (or
	       (and
		 (setq kw
			(getkword
			  (strcat
			    "\nEntrez le niveau d'imbrication de slection de bloc [Bloc/Entit/Aucun] <"
			    *MsFreezeNestingLevel*
			    ">:"
			  )
			)
		 )
		 (setq *MsFreezeNestingLevel* kw)
	       )
	       (setq kw *MsFreezeNestingLevel*)
	     )
	    )
	    ((= ent "annUler")
	     (if u-lst
	       (progn
		 (vla-put-Freeze (vla-item *layers* (setq lay (car u-lst))) :vlax-false)
		 (vla-regen *acdoc* acActiveViewport)
		 (setq fr    (vl-sort (cons lay fr) '<)
		       th    (vl-remove (strcat lay " *") th)
		       u-lst (cdr u-lst)
		       freeze (vl-remove lay freeze)
		 )
	       )
	       (princ "\nTout a t annul.")
	     )
	    )
	    (T
	      (setq lay	(vla-get-Layer
			  (vlax-ename->vla-object
			    (cond
			      ((or (= 2 (length ent))
				   (= *MsFreezeNestingLevel* "Entit")
			       )
			       (car ent)
			      )
			      ((= *MsFreezeNestingLevel* "Bloc")
			       (car (last ent))
			      )
			      ((= *MsFreezeNestingLevel* "Aucun")
			       (last (last ent))
			      )
			    )
			  )
			)
	      )
	     (if (= lay (getvar "clayer"))
	       (alert
		 (strcat "\""
			 lay
			 "\" est le calque courant\nIl ne peut tre gel"
		 )
	       )
	       (if (not (member lay freeze))
		 (progn
		   (vla-put-Freeze (vla-item *layers* lay) :vlax-true)
		   (setq u-lst	(cons lay u-lst)
			 th	(vl-sort (cons (strcat lay " *") th) '<)
			 fr	(vl-remove lay fr)
			 freeze	(cons lay freeze)
		   )
		 )
	       )
	     )
	    )
	  )
	)
      )
    )
  )
  (unload_dialog dcl_id)
  (vl-file-delete tmp)
  (list freeze thaw)
)

;;=========================================================;;

;; Rinitialisation au dmarrage

(and
  (not *MSpaceFreeze*)
  (vlax-ldata-get "MSpaceFreeze" "frozen")
  (or *acdoc*
      (setq *acdoc* (vla-get-activeDocument (vlax-get-acad-object)))
  )
  (or *layers* (setq *layers* (vla-get-layers *acdoc*)))
  (setq	*MSpaceFreeze*
	 (vlr-miscellaneous-reactor
	   nil
	   '((:vlr-layoutSwitched . msfreezerea))
	 )
  )
)