(defun c:spurge

       (/ AcDoc ss n obj name bloc ent r_lst x_lst p_lst c_lst m)

  (vl-load-com)

  (setq AcDoc (vla-get-ActiveDocument (vlax-get-acad-object)))


  ;; Purge les xrefs et rasters non rfrences

  (c:xref_purge)

  (c:raster_purge)


  ;; r_lst : liste des blocs et "sous-blocs" insrs

  ;; x_lst : liste des xrefs insres

  (setq ss (ssget "_X" '((0 . "INSERT"))))

  (if ss

    (progn

      (repeat (setq n (sslength ss))

        (setq

          obj (vlax-ename->vla-object (ssname ss (setq n (1- n))))

        )

        (if (vlax-property-available-p obj 'EffectiveName)

          (setq name (vla-get-EffectiveName obj))

          (setq name (vla-get-Name obj))

        )

        (if (= :vlax-true

               (vla-get-isXref

                 (vla-item (vla-get-Blocks AcDoc) name)

               )

            )

          (if (not (member name x_lst))

            (setq x_lst (cons name x_lst))

          )

          (if (not (member name r_lst))

            (setq r_lst (cons name r_lst))

          )

        )

      )

      ;; Ajout des "sous-blocs" des blocs insrs  r_lst

      (setq n 0)

      (if r_lst

        (while (setq name (nth n r_lst))

          (setq bloc (vla-item (vla-get-blocks acDoc) name))

          (repeat (setq m (vla-get-count bloc))

            (setq ent (vla-item bloc (setq m (1- m))))

            (if (and (= (vla-get-ObjectName ent) "AcDbBlockReference")

                     (not (member (vla-get-name ent) r_lst))

                )

              (setq

                r_lst

                 (reverse (cons (vla-get-Name ent) (reverse r_lst)))

              )

            )

          )

          (setq n (1+ n))

        )

      )

    )

  )


  (setq p_lst T)

  (while p_lst

    (vla-PurgeAll AcDoc)

    ;; c_lst liste des dfinitions de blocs de la collection

    (setq c_lst nil)

    (repeat (setq n (vla-get-count (vla-get-blocks AcDoc)))

      (setq

        c_lst

         (cons (vla-get-name

                 (vla-item (vla-get-blocks AcDoc) (setq n (1- n)))

               )

               c_lst

         )

      )

    )

    ;; p_lst : liste des blocs  purger, soit les blocs de la collection ...

    ;; ... moins les blocs "*Model_Space" "*Paper_Space*" et les blocs insres

    (setq p_lst (vl-remove-if

                  '(lambda (x)

                     (or (= (substr x 1 1) "*")

                         (member x r_lst)

                     )

                   )

                  c_lst

                )

    )

    ;; ... moins les xrefs insres et les blocs qu'elles contiennent

    (mapcar '(lambda (x)

               (setq p_lst

                      (vl-remove-if

                        '(lambda (y)

                           (wcmatch y (strcat x "*"))

                         )

                        p_lst

                      )

               )

             )

            x_lst

    )

  )

  (vla-AuditInfo AcDoc :vlax-true)

  (princ)

)