// Next available MSG number is   494
// MODULE_ID ACAD_DCL_
//
//
//  acad.dcl - AutoCAD dialogs
//
//////////////////////////////////////////////////////////////////////////////
//
//  Copyright 2016 Autodesk, Inc.  All rights reserved.
//
//  Use of this software is subject to the terms of the Autodesk license 
//  agreement provided at the time of installation or download, or which 
//  otherwise accompanies this software in either electronic or hard copy form.   
//
//////////////////////////////////////////////////////////////////////////////
//

//  This file should not be modified when used with AutoCAD.
//  Modification to the dialog definitions can have serious adverse
//  effects on the use of the product.  Since no modifications to this
//  file are allowed, there should be no need for any internal error
//  checking on the contents of this file, hence we disable audit
//  checks by default.

acad_snap : dialog {
        label = "Aides au dessin";
        : row {
            : column {
                : boxed_column {
                    label = "Modes";
                    : toggle {
                        label = "&Ortho";
                        key = "ortho";
                    }
                    : toggle {
                        label = "Remp&lir solide";
                        key = "fill";
                    }
                    : toggle {
                        label = "&Texte rapide";
                        key = "qtext";
                    }
                    : toggle {
                        label = "Mar&ques";
                        key = "blips";
                    }
                    : toggle {
                        label = "S&urbrillance";
                        key = "hilite";
                    }
                    : toggle {
                        label = "Grou&pes";
                        key = "group";
                    }
                    : toggle {
                        label = "Hachu&res";
                        key = "hatch";
                    }

                }
            }
            : boxed_column {
                label = "Accroch&age";
                : toggle {
                    label = "Active";
                    key = "snap";
                }
                : edit12_box {
                    label = "Espacement &X";
                    key = "s_xsp";
                    errmsg = "Accrocher en X";
                }
                : edit12_box {
                    label = "Espacement &Y";
                    key = "s_ysp";
                    errmsg = "Accrocher en Y";
                }
                : edit12_box {
                    label = "Angle a&ccr.";
                    key = "s_ang";
                    errmsg = "Angle d'accrochage";
                }
                : edit12_box {
                    label = "&Base X";
                    key = "xbase";
                    errmsg = "Accrocher au point de base X";
                }
                : edit12_box {
                    label = "Ba&se Y";
                    key = "ybase";
                    errmsg = "Accrocher au point de base Y";
                }
            }
            : column {
                : boxed_column {
                    label = "&Grille";
                    fixed_height = true;
                    : toggle {
                        label = "Active";
                        key = "grid";
                    }
                    : edit12_box {
                        label = "Espace&ment X";
                        key = "g_xsp";
                        errmsg = "Espacement de la grille en X";
                    }
                    : edit12_box {
                        label = "Espaceme&nt Y";
                        key = "g_ysp";
                        errmsg = "Espacement de la grille en Y";
                    }
                }
                : boxed_column {
                    label = "Accr/&Grille isomtrique";
                    : toggle {
                        label = "Active";
                        key = "iso";
                    }
                    : radio_row {
                        key = "isorad";
                        : radio_button {
                            label = "Gauch&e";
                            key = "ileft";
                        }
                        : radio_button {
                            label = "&Haut";
                            key = "itop";
                        }
                        : radio_button {
                            label = "&Droite";
                            key = "iright";
                        }
                    }
                }
            }
       }
       ok_cancel_help_errtile;
}

rq_chroma :dialog {
    label = "Slectionner une couleur";
    key = "chroma";                   // used by Help button to obtain label
    std_rq_color;
}

lt_text: text {
    width = 25;
}

lt_image: image_button {
    height = 1;
    width = 15;
    allow_accept = true;
}

acad_tstyle : dialog {
    label = "Slectionner le style de texte";
    : row {
        : column {
            : list_box {
                key = "style_list";
                width = 16;
                height = 8;
                allow_accept = true;
            }
            : button {
                label = "Tout a&fficher...";
                key = "showall";
            }
        }
        : column {
            : image {
                key = "style_image";
                height = 7;
                width = 20;
            }
            : edit_box {
                key = "style_sample";
                label = "Te&xte d'exemple";
                edit_width = 6;
                fixed_width = true;
                alignment = centered;
            }
        }
    }
    spacer;
    : edit_box {
        key = "style_edit";
        label = "Nom de st&yle:";
        edit_width = 31;
        edit_limit = 217;
        fixed_width = true;
        allow_accept = true;
    }
    : row {
        : paragraph {
            : text_part {
                label = "Police:";
            }
            : text_part {
                label = "Hauteur:";
            }
            : text_part {
                label = "Largeur:";
            }
            : text_part {
                label = "Inclinaison:";
            }
            : text_part {
                label = "Gnration:";
            }
        }
        : paragraph {
            : text_part {
                key = "font";
                width = 32;
            }
            : text_part {
                key = "height";
                width = 32;
            }
            : text_part {
                key = "width";
                width = 32;
            }
            : text_part {
                key = "oblique";
                width = 32;
            }
            : text_part {
                key = "gen";
                width = 32;
            }
        }
    }
    ok_cancel_err;
}

acad_tstyle_sym : dialog {
    key = "acad_tstyle_sym";
    label = "Jeu de symboles";
    : text {
        key = "page";
        width = 10;
    }
    : image {
        key = "showall";
        color = graphics_background;
        height = 16;
        width = 70;
    }
    : row {
        : ok_button {
            is_cancel = true;
        }
        : button {
            label = "Page &prcdente";
            key = "pagedown";
            width = 10;
        }
        : button {
            label = "Page &suivante";
            key = "pageup";
            width = 10;
        }
    }
}

acad_icon: dialog {
        key = "label";
        initial_focus               = "listbox";
        : row {
            : list_box {
// ----->                width               = 20;
// ----->                height              = 21;
                width               = 30;
                height              = 50;
                fixed_height        = true;
                key                 = "listbox";
                allow_accept        = true;
            }
            : column {
                : row {
                    : icon_image {
                        key         = "icon1";
                    }
                    : icon_image {
                        key         = "icon2";
                    }
                    : icon_image {
                        key         = "icon3";
                    }
                    : icon_image {
                        key         = "icon4";
                    }
		    : icon_image {
                        key         = "icon5";
                    }
                    : icon_image {
                        key         = "icon6";
                    }
                }
                : row {
                    
                    : icon_image {
                        key         = "icon7";
                    }
                    : icon_image {
                        key         = "icon8";
                    }
                    : icon_image {
                        key         = "icon9";
                    }
                    : icon_image {
                        key         = "icon10";
                    }
                    : icon_image {
                        key         = "icon11";
                    }
                    : icon_image {
                        key         = "icon12";
                    }
                }
               
                : row {
                    : icon_image {
                        key         = "icon13";
                    }
                    : icon_image {
                        key         = "icon14";
                    }
                    : icon_image {
                        key         = "icon15";
                    }
                    : icon_image {
                        key         = "icon16";
                    }
                    : icon_image {
                        key         = "icon17";
                    }
                    : icon_image {
                        key         = "icon18";
                    }
                }
                : row {
                   
                    : icon_image {
                        key         = "icon19";
                    }
                    : icon_image {
                        key         = "icon20";
                    }
                    : icon_image {
                        key         = "icon21";
                    }
                    : icon_image {
                        key         = "icon22";
                    }
                    : icon_image {
                        key         = "icon23";
                    }
                    : icon_image {
                        key         = "icon24";
                    }
                }
/*
 *              : row {
 *                  : icon_image {
 *                      key         = "icon21";
 *                  }
 *                  : icon_image {
 *                      key         = "icon22";
 *                  }
 *                  : icon_image {
 *                      key         = "icon23";
 *                  }
 *                  : icon_image {
 *                      key         = "icon24";
 *                  }
 *              }
 */
            }
        }
        : row {
            : row {
                spacer_0;
                : row {
                    fixed_width = true;
                    : button {
                        label = "&Prcdent";
                        key = "prev";
                        width = 8;
                    }
                    :spacer {
                        width = 2;
                    }
                    :button {
                        label = "  Suiva&nt  ";
                        key = "next";
                        width = 8;
                    }
                }
                spacer_0;
            }
            spacer;
            ok_cancel;
        }
}

acad_mtprop_edit_box : edit_box {
    edit_width = 20;
    edit_limit = 30;
}

acad_mtprop_popup_list : popup_list {
    edit_width = 24;
}

acad_mtprop : dialog {
    label = "Proprits du texte multiple";
    :boxed_column {
        label = "Contenu";
        :acad_mtprop_popup_list {
            label = "&Style de texte:";
            key = "sty";
        }
        :acad_mtprop_edit_box {
            label = "&Hauteur de texte:";
            key = "hgt";
        }
        :acad_mtprop_popup_list {
            label = "&Direction:";
            list = "Gauche  droite\nHaut en bas";
            key = "dir";
        }
    }
    :boxed_column {
        label = "Objet";
        :acad_mtprop_popup_list {
            label = "A&ncrage:";
            list = "HautGauche\nHautCentre\nHautDroite\nMilieuGauche\nMilieuCentre\nMilieuDroite\nBasGauche\nBasCentre\nBasDroite";
            key = "att";
        }
        :acad_mtprop_edit_box {
            label = "&Largeur:";
            key = "wid";
        }
        :acad_mtprop_edit_box {
            label = "&Rotation:";
            key = "rot";
        }
    }
    ok_cancel_help_errtile;
}

acad_plan6 : dialog {
    label = "SCU";
    : concatenation {
        : text_part {
            label = "Nom: ";
        }
        : text_part {
            label = "*Gnral*";
            key = "name";
            width = 40;
        }
    }
    : row {
        : boxed_column {
            label = "Origine";
            : concatenation {
                : text_part {
                    label = "X=";
                }
                : text_part {
                    key = "00";
                    width = 12;
                }
            }
            : concatenation {
                : text_part {
                    label = "Y=";
                }
                : text_part {
                    key = "10";
                    width = 12;
                }
            }
            : concatenation {
                : text_part {
                    label = "Z=";
                }
                : text_part {
                    key = "20";
                    width = 12;
                }
            }
        }
        : boxed_column {
            label = "Axe X";
            : concatenation {
                : text_part {
                    label = "X=";
                }
                : text_part {
                    key = "01";
                    width = 12;
                }
            }
            : concatenation {
                : text_part {
                    label = "Y=";
                }
                : text_part {
                    key = "11";
                    width = 12;
                }
            }
            : concatenation {
                : text_part {
                    label = "Z=";
                }
                : text_part {
                    key = "21";
                    width = 12;
                }
            }
        }
        : boxed_column {
            label = "Axe Y";
            : concatenation {
                : text_part {
                    label = "X=";
                }
                : text_part {
                    key = "02";
                    width = 12;
                }
            }
            : concatenation {
                : text_part {
                    label = "Y=";
                }
                : text_part {
                    key = "12";
                    width = 12;
                }
            }
            : concatenation {
                : text_part {
                    label = "Z=";
                }
                : text_part {
                    key = "22";
                    width = 12;
                }
            }
        }
        : boxed_column {
            label = "Axe Z";
            : concatenation {
                : text_part {
                    label = "X=";
                }
                : text_part {
                    key = "03";
                    width = 12;
                }
            }
            : concatenation {
                : text_part {
                    label = "Y=";
                }
                : text_part {
                    key = "13";
                    width = 12;
                }
            }
            : concatenation {
                : text_part {
                    label = "Z=";
                }
                : text_part {
                    key = "23";
                    width = 12;
                }
            }
        }
    }
    : ok_button {
        is_cancel = true;
    }
}

acad_plan : dialog {
    label = "Contrle des SCU";
    initial_focus = "listbox";
    spacer;
    : list_box {
        label = "&Noms des SCU";
        tabs = "34";
        key = "listbox";
        width = 44;
        tab_truncate = true;
    }
    : row {
        : button {
            label = "&Courant";
            key = "cur";
        }
        : button {
            label = "&Effacer";
            key = "delete";
        }
        : button {
            label = "&Proprits SCU...";
            key = "list";
        }
    }
    : row {
        : button {
            label = "&Renommer en:";
            key = "rename";
            fixed_width = true;
        }
        : edit_box {
            key = "rename_edit_box";
            edit_width = 28;
            edit_limit = 217;
        }
    }
    ok_cancel_help_errtile;
}

acad_txtedit : dialog {
    label = "Editer texte";
    initial_focus = "text_edit";
    : edit_box {
        label = "Texte:";
        key = "text_edit";
        edit_width = 40;
        edit_limit = 2048;
        allow_accept = true;
    }
    ok_cancel;
}

acad_attedit : dialog {
    label = "Editer une dfinition d'attribut";
    initial_focus = "tag_edit";
    : edit_box {
        key = "tag_edit";
        label = "Etiquette:";
        edit_width = 40;
        edit_limit = 2048;
    }
    : edit_box {
        key = "prompt_edit";
        label = "Description:";
        edit_width = 40;
        edit_limit = 2048;
    }
    : edit_box {
        key = "default_edit";
        label = "Valeur par dfaut:";
        edit_width = 40;
        edit_limit = 2048;
    }
    ok_cancel;
    : errtile { width = 45; }
}

acad_dlfname : dialog {               // Single-file dialog
    initial_focus = "fedit";
    key = "dlfname";
    files_topdf;
    : row {
        : list_box {
            label = "&Rpertoires:";
            key = "dirbox";
            width = 15;
        }
        : list_box {
            label = "F&ichiers";
            key = "filebox";
            width = 15;
            allow_accept = true;
        }
        : column {
            : image {          // Drawing icon image will go here
                key = "icon";
                color = dialog_background;    // Invisible
                height = 4;
                aspect_ratio = 1.4;
                fixed_height = true;
                fixed_width = true;
            }
            : button {
                label = "&Ouvrir";
                key = "typeit";
            }
            : button {
                label = "&Par dfaut";
                key = "default";
            }
        }
    }
    files_bottomdf;
}

//  acad_dlfmulti is used by the FILES command's Delete and Unlock
//  options.  It is similar to acad_dlfname (above), except that:
//
//    - its file listbox has the "multiple_select" attribute,
//    - its file listbox does not have the "allow_accept" attribute,
//    - it has additional "Select all" and "Clear all" buttons, and
//    - its title bar label is slightly different.
//
//  Modifications to either dialog should be examined for their relevance
//  to the other.

acad_dlfmulti : dialog {              // Multiple-file dialog
    initial_focus = "fedit";
    key = "dlfname";
    files_topdf;
    : row {
        : list_box {
            label = "&Rpertoires";
            key = "dirbox";
            width = 15;
        }
        : list_box {
            label = "F&ichiers";
            key = "filebox";
            width = 15;
            multiple_select = true;
        }
        : column {
            : image {          // Drawing icon image will go here
                key = "icon";
                color = dialog_background;    // Invisible
                alignment = centered;
                height = 4;
                aspect_ratio = 1.4;
                fixed_height = true;
                fixed_width = true;
            }
            spacer_1;
            : button {
                label = "&Tout slectionner";
                key = "all";
            }
            : button {
                label = "T&out effacer";
                key = "clear";
                is_enabled = false;
            }
            spacer_1;
            : button {
                label = "&Ouvrir";
                key = "typeit";
            }
            : button {
                label = "&Par dfaut";
                key = "default";
            }
        }
    }
    files_bottomdf;
}

acad_files : dialog {
    label = "Utilitaires de fichiers";
    initial_focus = "exit";
    : row {
        : column {
            : button {
                label = "&Rpertorier les fichiers... ";
                key = "list";
            }
            : button {
                label = "&Effacer des fichiers...";
                key = "delete";
            }
        }
        : column {
            : button {
                label = " &Copier un fichier... ";
                key = "copy";
            }
            : button {
                label = "&Dverrouiller fichiers...";
                key = "unlock";
            }
        }
        : column {
            : button {
                label = "Reno&mmer un fichier...";
                key = "rename";
            }
            : help_button {
                fixed_width = false;
            }
        }
    }
    errtile;
    : button {
        label = "     &Quitter     ";
        key = "cancel";
        fixed_width = true;
        alignment = centered;
        is_cancel = true;
        is_default = true;
    }
}

acad_info : dialog {
    label = "Information sur le programme";    // Overridden by caller
    key = "acad_info";
    : row {
        : image {
            key = "logo";
            width = 8;
            aspect_ratio = 1.0;
            fixed_height = true;
            alignment = top;
            color = dialog_background;
        }
        : paragraph {
            : text_part {
                key = "text1";
                width = 63;
            }
            : text_part {
                key = "text2";
                width = 63;
            }
            : text_part {
                key = "text3";
                width = 63;
            }
            : text_part {
                key = "text4";
                width = 63;
            }
            : text_part {
                key = "text5";
                width = 63;
            }
            : text_part {
                key = "text6";
                width = 63;
            }
            : text_part {
                key = "text7";
                width = 63;
            }
            : text_part {
                key = "text8";
                width = 63;
            }
            : text_part {
                key = "text9";
                width = 63;
            }
            : text_part {
                key = "text10";
                width = 63;
            }
        }
    }
    spacer;
    : list_box {
        width = 63;
        key = "listbox";
    }
    : ok_button {                     // Permit exit via either ENTER
        is_cancel = true;             //   or CTRL-C.
    }
}

init_view : dialog {

    key = "title";
    initial_focus = "listbox";
    : list_box {
        tabs = "33";
        width = 40;
        key = "listbox";
        allow_accept = true;
    }
    ok_cancel_err;
}




acad_plot : dialog {
    label = "Imprimer / Configuration du traceur";
    : row {
        : column {
            : boxed_column {
                label = "Priphriques, informations actuelles";
                : text {
                    key = "userid";
                    width = 35;
                }
                : button {
                    label = "Priphri&que, valeurs par dfaut...";
                    fixed_width = true;
                    key = "devsel";
                    alignment = centered;
                }
            }
            : boxed_row {
                label = "Paramtres des plumes";
                children_fixed_width = true;
                : button {
                    label = "Choi&x des plumes...";
                    key = "assign";
                }
                : button {
                    label = "O&ptimiser...";
                    key = "optimize";
                }
            }
            : boxed_column {
                label = "Paramtres supplmentaires";
                : row {
                    : radio_column {
                        fixed_width = true;
                        : radio_button {
                            label = "Afficha&ge";
                            key = "D";
                        }
                        : radio_button {
                            label = "&Etendu";
                            key = "E";
                        }
                        : radio_button {
                            label = "&Limites";
                            key = "L";
                        }
                        : radio_button {
                            label = "&Vue";
                            key = "V";
                        }
                        : radio_button {
                            label = "Fe&ntre";
                            key = "W";
                        }
                    }
                    : column {
                        : edit12_box {
                            label = "Rsolution de texte";
                            key = "textreso";
                            errmsg = "Text Resolution";
                        }
                        : toggle {
                            label = "Remplissage de texte";
                            key = "textfill";
                        }
                        : toggle {
                            label = "&Masquer les lignes";
                            key = "hide";
                        }
                        : toggle {
                            label = "Ajuster rempl&issage";
                            key = "plfill";
                        }
                        : toggle {
                            label = "Tracer dans un fic&hier";
                            key = "file";
                        }
                        : toggle {
                            label = "Auto&spool";
                            key = "aspool";
                        }
                    }
                }
                : row {
                    alignment = centered;
                    : button {
                        label = "&Vue...";
                        key = "view";
                        fixed_width = true;
                    }
                    : button {
                        label = "&Fentre...";
                        key = "selwind";
                        fixed_width = true;
                    }
                    : button {
                        label = "Fic&hier...";
                        key = "sfile";
                        fixed_width = true;
                    }
                }
            }
        }
        : column {
                : boxed_column {
                    label = "Format et orientation du papier";
                    : row {
                        : radio_column {
                            fixed_width = true;
                            : radio_button {
                                label = "Po&uces";
                                key = "I";
                            }
                            : radio_button {
                                label = "&mm";
                                key = "M";
                            }
                        }
                        : row {
                            fixed_width = true;
                            : button {
                                label = "F&ormat...";
                                key = "sizbuttn";
                                fixed_width = true;
                            }
                            : text {
                                key = "size";
                                width = 6;
                            }
                            : column {
                                spacer;
                                : image {
                                    key = "vec_image";
                                    width = 4.0;
                                    fixed_width = true;
                                    aspect_ratio = 1.0;
                                    color = dialog_background;
                                }
                                spacer;
                            }
                        }
                    }
                    : text {
                        key = "area";
                        width = 25;
                    }
                }
                : boxed_column {
                    label = "Echelle, rotation et origine";
                    : button {
                        label = "Rotatio&n et origine...";
                        key = "rot&or";
                        alignment = centered;
                        fixed_width = true;
                    }
                    : row {
                        : column {
                            children_fixed_width = true;
                            : text {
                                key = "pu";
                                width = 14;
                                alignment = right;
                            }
                            : edit_box {
                                edit_width = 10;
                                key = "punit";
                                alignment = centered;
                            }
                        }
                        : column {
                            children_fixed_width = true;
                            children_alignment = centered;
                            : text {
                                label = "=";
                            }
                            : text {
                                label = "=";
                            }
                        }
                        : column {
                            children_fixed_width = true;
                            : text {
                                label = "Units de dessin";
                            }
                            : edit_box {
                                edit_width = 10;
                                key = "dunit";
                                alignment = centered;
                            }
                        }
                    }
                    : toggle {
                        label = "A&juster au format";
                        key = "fit";
                    }
                }
                : boxed_column {
                    label = "Aperu du trac";
                    : row {
                        children_fixed_width = true;
                        : button {
                            label = "Ape&ru...";
                            key = "prev";
                        }
                        : radio_row {
                            : radio_button {
                                label = "Ca&dre";
                                key = "earea";
                            }
                            : radio_button {
                                label = "&Total";
                                key = "full";
                            }
                        }
                    }
                }
        }
    }
    ok_cancel_help;
    : row {
        : errtile { fixed_width = true; }

        // This spacer_0 between the two fixed-width items serves
        // to left-justify the first and right-justify the second,
        // since it's the only flexible-width item in the row.
        spacer_0;

        : row {
            fixed_width = true;
            : text {
                key = "zero";
                width = 3;
            }
            : image {
                key = "pre_image";
                color = dialog_background;
                height = 1;
                width = 18;
            }
            : text {
                key = "comp";
                width = 5;
            }
        }
    }
}

acad_plwin : dialog {
    label = "Fentre d'impression";
        : button {
            label = "&Saisir <";
            key = "pick";
            fixed_width = true;
        }
            : boxed_row {
                label = "&Premier coin";
                : edit_box {
                    label = "   X:";
                    key = "fpx";
                    edit_width = 10;
                }
                : edit_box {
                    label = "   Y:";
                    key = "fpy";
                    edit_width = 10;
                }
            }
            : boxed_row {
                label = "Se&cond coin";
                : edit_box {
                    label = "   X:";
                    key = "spx";
                    edit_width = 10;
                }
                : edit_box {
                    label = "   Y:";
                    key = "spy";
                    edit_width = 10;
                }
            }
        ok_cancel_err;
}

acad_plopt : dialog {
    aspect_ratio = 0;
    label = "Optimiser le dplacement des plumes";
    : column {
        : toggle {
            label = "&Pas d'optimisation";
            key = "0";
        }
        : toggle {
            label = "&Recherche des extrmits";
            key = "1";
        }
        : toggle {
            label = "&Tri des plumes";
            key = "2";
        }
        : toggle {
            label = "Optimisation part&ielle des mouvements";
            key = "3";
        }
        : toggle {
            label = "Optimis&ation complte des mouvements";
            key = "4";
        }
        : toggle {
            label = "Elimination des vecteurs &horizontaux et verticaux superposs";
            key = "5";
        }
        : toggle {
            label = "Elimination des vecteurs &diagonaux superposs";
            key = "6";
        }
    }
    ok_cancel;
}

acad_plsize : dialog {
    label = "Format du papier";
    : row {
        : column {
            : concatenation {
                : text_part {
                    label = "&Format";
                    width = 8;
                }
                : text_part {
                    label = "Largeur";
                    width = 9;
                }
                : text_part {
                    label = "Hauteur";
                }
            }
            : list_box {
                key = "listbox";
                tabs = "0 8 17";
                width = 28;
                height = 13;
            }
        }
        spacer_1;
        : column {
            : row {
                : text_part {
                    label = "Format";
                    width = 8;
                }
                : text_part {
                    label = "Largeur";
                    width = 11;
                }
                : text_part {
                    label = "Hauteur";
                }
            }
            spacer_0;
            : row {
                : text_part {
                    label = "&UTILISATEUR:";
                    width = 8;
                }
                : edit_box {
                    key = "0w";
                    edit_width = 10;
                }
                : edit_box {
                    key = "0h";
                    label = " ";
                    edit_width = 10;
                }
            }
            : row {
                : text_part {
                    label = "UTIL. &1:";
                    width = 8;
                }
                : edit_box {
                    key = "1w";
                    edit_width = 10;
                }
                : edit_box {
                    key = "1h";
                    label = " ";
                    edit_width = 10;
                }
            }
            : row {
                : text_part {
                    label = "UTIL. &2:";
                    width = 8;
                }
                : edit_box {
                    key = "2w";
                    edit_width = 10;
                }
                : edit_box {
                    label = " ";
                    key = "2h";
                    edit_width = 10;
                }
            }
            : row {
                : text_part {
                    label = "UTIL. &3:";
                    width = 8;
                }
                : edit_box {
                    key = "3w";
                    edit_width = 10;
                }
                : edit_box {
                    label = " ";
                    key = "3h";
                    edit_width = 10;
                }
            }
            : row {
                : text_part {
                    label = "UTIL. &4:";
                    width = 8;
                }
                : edit_box {
                    key = "4w";
                    edit_width = 10;
                }
                : edit_box {
                    label = " ";
                    key = "4h";
                    edit_width = 10;
                }
            }
            : row {
                : column {
                    spacer_1;
                    : row {
                        alignment = left;
                        : text_part {
                            label = "L'orientation est";
                            fixed_width = true;
                        }
                        : text_part {
                            key = "land";
                            width = 12;
                        }
                    }
                    spacer;
                }
                : column {
                    spacer;
                    : image {
                        key = "vec_image";
                        width = 4.0;
                        fixed_width = true;
                        aspect_ratio = 1.0;
                        color = dialog_background;
                    }
                    spacer;
                }
            }
        }
    }
    ok_cancel_err;
}

acad_plpen : dialog {
    label = "Choix des plumes";
    : column {
        : row {
            : paragraph {
                : concatenation {
                    : text_part {
                        label = "Couleur  Plume";
                        key = "1";
                        width = 20;
                    }
                    : text_part {
                        label = "Type ligne";
                        key = "2";
                        width = 11;
                    }
                    : text_part {
                        label = "Vitesse";
                        key = "3";
                        width = 7;
                    }
                    : text_part {
                        label = "Largeur";
                        key = "4";
                    }
                }
                : list_box {
                    key = "listbox";
                    tabs = "2 11 22 32 38";
                    width = 50;
                    multiple_select = true;
                }
            }
            : boxed_column {
                label = "Modifier les valeurs";
                : row {
                    : text_part {
                        label = "Couleur:";
                        width = 10;
                        fixed_width = true;
                    }
                    : image {
                        key = "color_image";
                        width = 4.0;
                        height = 0.5;
                    }
                }
                : text {
                    width = 13;
                    key = "varies";
                }
                : row {
                    : text_part {
                        label = "&Plume:";
                        width = 10;
                        fixed_width = true;
                    }
                    : edit_box {
                        key = "penno";
                        edit_width = 8;
                    }
                }
                : row {
                    : text_part {
                        label = "&T. ligne:";
                        width = 10;
                        fixed_width = true;
                    }
                    : edit_box {
                        key = "ltype";
                        edit_width = 8;
                    }
                }
                : row {
                    : text_part {
                        label = "&Vitesse:";
                        width = 10;
                        fixed_width = true;
                    }
                    : edit_box {
                        key = "speed";
                        edit_width = 8;
                    }
                }
                : row {
                    : text_part {
                        label = "&Largeur:";
                        width = 10;
                        fixed_width = true;
                    }
                    : edit_box {
                        key = "width";
                        edit_width = 8;
                    }
                }
            }
        }
        : row {
            : button {
                label = "&Informations complmentaires...";
                key = "legend";
                fixed_width = true;
            }
            : spacer { width = 2; }
            : edit_box {
                label = "La&rgeur de plume:";
                key = "lpwidth";
                edit_width = 8;
                fixed_width = true;
            }
        }
    }
    ok_cancel_err;
}

acad_plpre : dialog {
    label = "Aperu de la zone de trac effective";
        : image {
            key = "pimage";
            height = 11.25;
            width = 25;
            fixed_width = true;
            fixed_height = true;
            alignment = centered;
        }
        : row {
            : image {
                key = "cpaper";
                width = 2.0;
                color = red;
                height = 0.1;
                fixed_width = true;
                fixed_height = true;
            }
            : text {
                key = "paper";
                width = 50;
            }
        }
        : row {
            : image {
                key = "earea";
                width = 2.0;
                color = blue;
                height = 0.1;
                fixed_width = true;
                fixed_height = true;
            }
            : text {
                key = "area";
                width = 50;
            }
        }
        : row {
            : image {
                key = "clip";
                width = 2.0;
                height = 0.1;
                fixed_width = true;
                fixed_height = true;
            }
            : text {
                key = "cliptxt";
                width = 50;
            }
        }
        : text {
            width = 50;
            key = "warn";
        }
        : list_box {
            height = 3;
            key = "listbox";
        }
    ok_only;
}

acad_plok : dialog {
   label = "Aperu du trac";
   : column {
       width = 15;
       : button {
           label = "&Panoramique et zoom";
           key = "zoomd";
       }
       : button {
           key = "accept";
           label = "&Fin de l'aperu";
           is_cancel = true;
       }
   }
}

acad_plokcan : dialog {
    label = "Aperu du trac";
    : column {
        width = 15;
        : button {
            label = "&Zoom Prcdent";
            key = "zoomd";
        }
        : button {
            key = "accept";
            label = "&Fin de l'aperu";
            is_cancel = true;
        }
    }
}

acad_devdesc : dialog {
    label = "Dcrivez le priphrique";
    : column {
        : text {
            label = "AutoCAD requiert une description du priphrique afin que vous puissiez le retrouver ultrieurement.";
        }
        : edit_box {
            edit_limit = 80;
            label = "Description:";
            key = "desc";
        }
    }
    ok_cancel;
}

acad_devinf : dialog {
    label = "Priphrique, valeurs par dfaut";
    : boxed_column {
                label = "Choix d'une configuration de priphrique";
                : list_box {
                        key = "listbox";
                        width = 60;
                        height = 6;
                        tabs = "36";
                }
                : concatenation {
                        : text_part {
                        label = "Fabricant: ";
                        fixed_width = true;
                        width = 14;
                        }
                        : text_part {
                        key = "device";
                        width = 50;
                        }
                }
                : concatenation {
                        : text_part {
                        label = "Port: ";
                        width = 6;
                        }
                        : text_part {
                        key = "port";
                        width = 50;
                        }
                }
    }
    : boxed_row {
                label = "Fichier de configuration";
            : column {
                    : text {
                            label = "Complet (PC2)";
                alignment = centered;
                    }
            : row {
                        : button {
                                label = "E&nregistrer...";
                                key = "savepc2";
                        }
                        : button {
                                label = "&Remplacer...";
                                key = "loadpc2";
                        }
            }
            }
        spacer_0;
        : column {
                    : text {
                            label = "Partiel (PCP - R12/R13)";
                alignment = centered;
                    }
            : row {
                        : button {
                                label = "&Enregistrer...";
                                key = "sfile";
                        }
                        : button {
                                label = "&Fusionner...";
                                key = "ffile";
                        }
            }
        }
    }
    : boxed_row {
                label = "Configuration spcifique du priphrique";
                : text_part {
                        label = "Paramtres: ";
                        width = 35;
                }
                : button {
                        label = "Affi&cher...";
                        key = "showreq";
                        is_enabled = false;
                }
                : button {
                        label = "&Modifier...";
                        key = "cfgreq";
                        is_enabled = false;
                }
    }
    ok_cancel_help_errtile;
}

acad_plferr : dialog {
    label = "Erreur avec le fichier des valeurs par dfaut";
    : list_box {
        width = 62;
        height = 8;
        key = "listbox";
    }
    : row {
        spacer_0;
        : row {
            fixed_width = true;
            : button {
                key = "save";
                label = "&Cration d'un fichier d'erreur";
            }
            : spacer {
                width = 2;
            }
            ok_only;
        }
        spacer_0;
    }
    errtile;
}

acad_rotor : dialog {
    label = "Rotation et origine du trac";
    : boxed_radio_row {
        label = "Rotation du trac";
        : radio_button {
            label = "&0";
            key = "0";
        }
        : radio_button {
            label = "&90";
            key = "90";
        }
        : radio_button {
            label = "&180";
            key = "180";
        }
        : radio_button {
            label = "&270";
            key = "270";
        }
    }
    : boxed_row {
        label = "Origine du trac";
        : edit_box {
            label = "Origine en &X:";
            key = "originx";
            edit_width = 10;
        }
        : edit_box {
            label = "Origine en &Y:";
            key = "originy";
            edit_width = 10;
        }
    }
    spacer;
    ok_cancel_err;
}


acad_dwgmod : dialog {
   label = "Enregistrer les modifications";
   initial_focus = "save";
   : column {
       : text {
           label = "Le dessin courant a t modifi.";
           alignment = centered;
       }
       : row {
           : button {
               label = "&Enregistrer...";
               is_default = true;
               key = "save";
           }
           : button {
               label = "&Ignorer les modifications";
               key = "discard";
           }
           : button {
               label = "&Annuler";
               is_cancel = true;
               key = "cancel";
           }
       }
   }
}

acad_newdwg : dialog {
    label = "Crer un nouveau dessin";
    initial_focus = "fedit";
    : boxed_column {
        : row {
            : button {
                label = "&Prototype...";
                key = "template";
            }
            : edit32_box {
                key = "protype";
            }
        }
        : column {
            : toggle {
                label = "Pa&s de prototype";
                key = "dflts";
                value = "0";
            }
            : toggle {
                label = "&Conserver comme fichier par dfaut";
                key = "retain";
                value = "0";
            }
        }
    }
    spacer_1;
    : column {
        : row {
            : button {
                label = "&Nom du nouveau dessin...";
                key = "fdialog";
            }
            : edit32_box {
                key = "fedit";
                allow_accept = true;
            }
        }
    }
    ok_cancel_err;
}

// acad_opendwg is used by the OPEN command and is the same as
// acad_dlfname except it has additional toggles:
//          Select Initial View and Read Only Mode
// and the title is fixed in the definition.

acad_opendwg : dialog {
    label = "Ouvrir un dessin";
    initial_focus = "fedit";
    files_topdf;
    : row {
        : list_box {
            label = "&Rpertoires:";
            key = "dirbox";
            width = 15;
        }
        : list_box {
            label = "F&ichiers:";
            key = "filebox";
            width = 15;
            allow_accept = true;
        }
        : column {
            : image {          // Drawing icon image will go here
                key = "icon";
                color = dialog_background;    // Invisible
                height = 6;
                aspect_ratio = 1.4;
                fixed_height = true;
                fixed_width = true;
            }
            : button {
                label = "&Ouvrir";
                key = "typeit";
            }
            : button {
                label = "&Par dfaut";
                key = "default";
            }
        }
    }
    : row {
        : toggle {
            label = "C&hoix vue initiale";
            key = "vselect";
            value = "0";
        }
        : toggle  {
            label = "Mode l&ecture seule";
            key = "read";
            value = "0";
        }
    }
    files_bottomdf;
}

acad_reinit : dialog {
    label = "Rinitialisation";
    : boxed_column {
        label = "Initialisation des ports d'E/S";
        : row {
            : toggle {
                label = "Nu&mriseur";
                key = "1";
                value = "0";
            }
        }
    }
    : boxed_column {
        label = "Initialisation du priphrique et du fichier";
        : toggle {
            label = "Numr&iseur";
            key = "g";
            value = "0";
        }
        : toggle {
            label = "Fichier P&GP";
            key = "p";
            value = "0";
        }
    }
    ok_cancel_help;
}

acad_wait : dialog {
   key = "title";
   initial_focus = "accept";
   width = 32;
   spacer;
   : column {
       fixed_width = true;
       fixed_height = true;
       alignment = centered;
       : button {
           key = "accept";
           label = "&Continuer";
           is_cancel = true;
       }
    }
    spacer;
}

fh_open : dialog {
    label = "Erreur de dfinition du contour";
    initial_focus = "accept";
    width = 30;
    spacer;
    : column {
        fixed_height = true;
        alignment = centered;
        : text {
            alignment = centered;
            label = "Le contour n'est pas ferm.";
        }
    }
    spacer_1;
    ok_look;
    spacer;
}


fh_outside : dialog {
    aspect_ratio = 0;
    label = "Erreur de dfinition du contour";
    initial_focus = "accept";
    width = 30;
    spacer;
    : column {
        fixed_height = true;
        alignment = centered;
        : text {
            alignment = centered;
            label = "Le point se trouve  l'extrieur du contour.";
        }
    }
    spacer_1;
    ok_look;
    spacer;
}


fh_on : dialog {
    aspect_ratio = 0;
    label = "Erreur de dfinition du contour";
    initial_focus = "accept";
    width = 30;
    spacer;
    : column {
        fixed_height = true;
        alignment = centered;
        : text {
            alignment = centered;
            label = "Le point se trouve exactement sur un objet.";
        }
    }
    spacer_1;
    ok_look;
    spacer;
}


fh_dup : dialog {
    aspect_ratio = 0;
    label = "Erreur de dfinition du contour";
    initial_focus = "accept";
    width = 30;
    spacer;
    : column {
        fixed_height = true;
        alignment = centered;
        : text {
            alignment = centered;
            label = "Le contour duplique un contour existant.";
        }
    }
    spacer_1;
    ok_only;
    spacer;
}


fh_nohatch : dialog {
    aspect_ratio = 0;
    label = "Erreur de hachures";
    width = 30;
    spacer;
    : column {
        fixed_height = true;
        alignment = centered;
        : text {
            alignment = centered;
            label = "Aucune hachure n'a t cre";
        }
    }
    spacer_1;
    ok_only;
    spacer;
}


fh_toodense : dialog {
    aspect_ratio = 0;
    label = "Erreur de hachures";
    width = 30;
    spacer;
    : column {
        fixed_height = true;
        alignment = centered;
        : text {
            alignment = centered;
            label = "Les hachures sont trop denses ou la taille des discontinuits est trop petite.";
        }
    }
    spacer_1;
    ok_only;
    spacer;
}


falert : dialog {
    label = "ATTENTION";
    spacer;
    : text {
        key = "alert_text_1";
        horizontal_alignment = centered;
        width = 50;
    }
    : text {
        key = "alert_text_2";
        horizontal_alignment = centered;
        width = 50;
    }
    spacer_1;
    ok_only;
    spacer;
}

big_button :button{
    fixed_width = true;
    width = 25;
}


look_button : retirement_button {
    label           = "&Visualiser";
    key             = "look";
    vertical_alignment = centered;
}


ok_look : column {
    : row {
        fixed_width = true;
        alignment = centered;
        : ok_button { is_cancel = true; }
        : spacer { width = 2; }
        look_button;
    }
}


next_button : button {
        label           = "Sui&vant";
        key             = "next";
        fixed_width     = true;
        width           = 9;
        vertical_alignment = centered;
        horizontal_alignment = centered;
}


prev_button : button {
        label           = "&Prcdent";
        key             = "previous";
        fixed_width     = true;
        width           = 9;
        vertical_alignment = centered;
        horizontal_alignment = centered;
}


pick_cancel : column {
    : row {
        fixed_width = true;
        alignment = centered;
        : button {
            label = "Chois&ir des points <";
            key = "accept";
            is_default = true;
        }
        : spacer { width = 1; }
        cancel_button;
        : spacer { width = 1; }
        help_button;
    }
}

//
// support functions
//

isopwidth : popup_list {
    label = "Lar&geurs de plumes ISO:";
    list = " \n0.13 mm\n0.18 mm\n0.25 mm\n0.35 mm\n0.5 mm\n0.7 mm\n1.0 mm\n1.4 mm\n2.0 mm\n";
    popup_height = 3;
    key = "isopenwidth";
    edit_width = 12;
}

text_35 : text {
    width = 35;
}


acad_group : dialog {
    label = "Grouper des objets";
    initial_focus = "name";
    : column {
        : concatenation {
            : text_part {
                label = "Nom &de groupe";
                width = 32;
            }
            : text_part {
                label = "Slectionnable";
            }
        }
        : list_box {
            tabs = "36";
            key = "grp_list";
            width = 48;
            height = 18;
            tab_truncate = true;
        }
    }
    : boxed_column {
        label = "Identification de groupe";
        : column {
            : row {
                : text_part {
                    label = "Nom de &groupe:";
                    width = 13;
                }
                : edit_box {
                    key = "name";
                    edit_width = 32;
                    edit_limit = 217;
                }
            }
            : row {
                : text_part {
                    label = "De&scription:";
                    width = 13;
                }
                : edit_box {
                    key = "desc";
                    edit_width = 32;
                    edit_limit = 448;
                }
            }
        }
        : row {
            children_fixed_width = true;
            : button {
                label = "Trou&ver par nom <";
                key = "find";
            }
            : button {
                label = "Sur&brillance <";
                key = "h_light";
            }
            : toggle {
                label = "Incl&ure Sansnom";
                key = "anon";
            }
        }
    }
    : boxed_column {
        label = "Crer un groupe";
        : row {
            alignment = centered;
            : button {
                label = "&Nouveau <";
                key = "add_new";
            }
            spacer_1;
            : toggle {
                label = "Sle&ctionnable";
                value = "1";
                key = "select";
            }
            : toggle {
                label = "Sansno&m";
                value = "0";
                key = "unnamed";
            }
        }
    }
    : boxed_column {
        label = "Changer le groupe";
        key = "chg_column";
        : row {
            : button {
                label = "Supprim&er <";
                key = "remove";
            }
            : button {
                label = "Ajou&ter <";
                key = "add";
            }
            : button {
                label = "Ren&ommer";
                key = "rename";
            }
            : button {
                label = "&Rorganiser...";
                key = "order";
            }
        }
        : row {
            : button {
                label = "Descr&iption";
                key = "chg_desc";
            }
            : button {
                label = "Dcom&poser";
                key = "explode";
            }
            : button {
                label = "S&lectionnable";
                key = "chg_select";
            }
        }
    }
    ok_cancel_help_errtile;
}


acad_grp_order : dialog {
    label = "Rorganiser un groupe";
    : column {
        : text {
            label = "&Nom du groupe";
        }
        : list_box {
            key = "grp_list";
            width = 45;
            height = 6;
        }
    }
    : boxed_column {
        label = "&Description";
        : text {
            key = "desc";
            width = 43;
        }
    }
    : boxed_column {
        children_fixed_width = true;
        : row {
            : text {
                key = "remove";
                width = 50;
                horizontal_alignment = right;
            }
            : edit_box {
                edit_width = 10;
                key = "from";
                horizontal_alignment = left;
            }
        }
        : row {
            : text {
                key = "replace";
                width = 50;
                horizontal_alignment = right;
            }
            : edit_box {
                edit_width = 10;
                key = "to";
                horizontal_alignment = left;
            }
        }
        : row {
            : text {
                key = "qtext";
                width = 50;
                horizontal_alignment = right;
            }
            : edit_box {
                edit_width = 10;
                key = "quantity";
                horizontal_alignment = left;
            }
        }
    }
    : row {
        key = "action";
        : button {
            label = "&Rorganiser";
            key = "reorder";
        }
        : button {
            label = "&Mettre en surbrillance";
            key = "hlight";
        }
        : button {
            label = "Revenir  la &position";
            key = "reverse";
        }
    }
    ok_cancel_help_errtile;
}

acad_grp_member : dialog {
    label = "Liste des membres du groupe";
    initial_focus = "accept";
    : list_box {
        key = "listbox";
        width = 35;
        height = 8;
        fixed_width = true;
    }
    spacer;
    : ok_button {
        is_cancel = true;
    }
}

acad_msg : dialog {
   label = "Grouper des objets";
   width = 32;
   : row {
       next_button;
       prev_button;
   }
   spacer_1;
   : ok_button {
       is_cancel = true;
   }
   errtile;
}

ddfcf : dialog {
  label        = "Tolrance gomtrique";
  :row {
      : boxed_column {
          label = "Sym.";
          children_fixed_height = true;
          children_fixed_width = true;
          : text {
             label = "";
          }
          spacer_1;
          : fcf_ibut {
             key         = "sym11";
          }
          spacer_1;
          : fcf_ibut {
             key         = "sym21";
          }
      }
      : boxed_column {
          label = "1re tolrance";
          children_fixed_height = true;
          children_fixed_width = true;
          : text {
              label = "Dia. Valeur  CM";
          }
          spacer_1;
          : row {
              : fcf_ibut {
                  key         = "sym12";
              }
              : fcf_ebox {
                  key         = "ebox11";
              }
              : fcf_ibut {
                  key         = "sym13";
              }
          }
          spacer_1;
          : row {
              : fcf_ibut {
                  key         = "sym22";
              }
              : fcf_ebox {
                  key         = "ebox21";
              }
              : fcf_ibut {
                  key         = "sym23";
              }
          }
      }

      : boxed_column {
          label = "2me tolrance";
          children_fixed_height = true;
          children_fixed_width = true;
          : text {
              label = "Dia. Valeur  CM";
          }
          spacer_1;
          : row {
               : fcf_ibut {
                   key         = "sym14";
               }
               : fcf_ebox {
                   key         = "ebox12";
               }
               : fcf_ibut {
                   key         = "sym15";
               }
          }
          spacer_1;
          : row {
              : fcf_ibut {
                  key         = "sym24";
              }
              : fcf_ebox {
                  key         = "ebox22";
              }
              : fcf_ibut {
                  key         = "sym25";
              }
          }
      }

      : boxed_column {
          label = "1re rf.";
          children_fixed_height = true;
          children_fixed_width = true;
          : text {
              label = "Rf. CM";
          }
          spacer_1;
          : row {
              : fcf_ebox1 {
                  key         = "ebox13";
              }
              : fcf_ibut {
                  key         = "sym16";
              }
          }
          spacer_1;
          : row {
              : fcf_ebox1 {
                  key         = "ebox23";
              }
              : fcf_ibut {
                  key         = "sym26";
              }
          }
      }

      : boxed_column {
          label = "2me rf.";
          children_fixed_height = true;
          children_fixed_width = true;
          : text {
              label = "Rf. CM";
          }
          spacer_1;
          : row {
              : fcf_ebox1 {
                  key         = "ebox14";
              }
              : fcf_ibut {
                  key         = "sym17";
              }
          }
          spacer_1;
          : row {
              : fcf_ebox1 {
                  key         = "ebox24";
              }
              : fcf_ibut {
                  key         = "sym27";
              }
          }
      }

      : boxed_column {
          label = "3me rf.";
          children_fixed_height = true;
          children_fixed_width = true;
          : text {
              label = "Rf. CM";
          }
          spacer_1;
          : row {
              : fcf_ebox1 {
                  key         = "ebox15";
              }
              : fcf_ibut {
                  key         = "sym18";
              }
          }
          spacer_1;
          : row {
              : fcf_ebox1 {
                  key         = "ebox25";
              }
              : fcf_ibut {
                  key         = "sym28";
              }
          }
      }
  }
  spacer_1;
  : column {
      children_fixed_height = true;
      : row {
          fixed_width = true;
          : text {
               label = "Hauteur:";
          }
          : fcf_ebox {
              key         = "ebox31";
          }
          : text {
               label = "Zone de tolrance projete:";
          }
          : fcf_ibut {
              key         = "sym31";
          }
      }
      spacer_1;
      : row {
          fixed_width = true;
          : text {
               label = "Identificateur de rfrence:";
          }
          : fcf_ebox {
              key         = "ebox32";
          }
      }
  }
  spacer_1;
  ok_cancel_help_errtile;
}

ddfcfsub: dialog {
  label        = "Symbole";
  : column {
   : row {
      : fcf_ibut1 {
        key          = "gdtj";      /* Position */
      }
      : fcf_ibut1 {
        key          = "gdtr";      /* Circularity */
      }
      : fcf_ibut1 {
        key          = "gdti";      /* Symmetry */
      }
      : fcf_ibut1 {
        key          = "gdtf";      /* Parallel */
      }
      : fcf_ibut1 {
        key          = "gdtb";       /* Perpendicular */
      }
    }
    : row {
      : fcf_ibut1 {
        key          = "gdta";      /* Angular */
      }
      : fcf_ibut1 {
        key          = "gdtg";      /* Cylindricity */
      }
      : fcf_ibut1 {
        key          = "gdtc";       /* Flatness */
      }
      : fcf_ibut1 {
        key          = "gdte";      /* Circularity */
      }
      : fcf_ibut1 {
        key          = "gdtu";      /* Straightness    */
      }
    }
    : row {
      : fcf_ibut1 {
        key          = "gdtd";      /* Profile of a surface */
      }
      : fcf_ibut1 {
        key          = "gdtk";      /* Line Profile */
      }
      : fcf_ibut1 {
        key          = "gdth";      /* Circular Runout */
      }
      : fcf_ibut1 {
        key          = "gdtt";      /* Total Runout    */
      }
      : fcf_ibut1 {
        key          = "gdt-";      /* Nothing */
      }
    }
  }
  spacer_1;
  ok_cancel_help_errtile;
}

ddfcfsub1: dialog {
  label        = "Condition de matire";
  : row {
      : fcf_ibut1 {
       key          = "gdtm";   /* Maximum */
      }
      : fcf_ibut1 {
       key          = "gdtl";   /* Least */
      }
      : fcf_ibut1 {
       key          = "gdts";   /* Regardless of feature size */
      }
      : fcf_ibut1 {
       key          = "gdt-";   /* Nothing */
      }
  }
  spacer_1;
  ok_cancel_help_errtile;
}


//==================================================================
// LispEd.dcl
//
//
// Prototype layout for single-line MText editor.


//==================================================================
// LispEd - main dialogue:

LispEd : dialog {
  label = "Edition texte multiple";
  initial_focus = "text";
  : edit_box {
    label = "Index:";
    key = "contents";
    edit_width = 40;
    edit_limit = 100;
    allow_accept = true;
  }
  spacer;
  : column {
    : row {
      fixed_width = true;
      alignment = centered;
      ok_button;
      : spacer { width = 2; }
      cancel_button;
      : spacer { width = 2; }
      : retirement_button {
        label = "Editeur...";
        mnemonic = "E";
        key = "mtexted";
      }
    }
  }
}

block_equal : dialog {
  key = "block_equal";
  label = "Nom du bloc de substitution";
    : text {
      label = "Le fichier choisi ne peut pas tre utilis comme nom de bloc.";
      alignment = centered;
    }
    : edit_box {
        label = "Nouveau nom de bloc:";
        key = "blockname";
        edit_width = 31;   /* Leave the edit window at pre-ESN length.  */
        edit_limit = 2040; /* Allow 255 MIF sequences for new symbol name. */
        alignment = centered;
        allow_accept = true;
    }
    ok_cancel_err;

}